print("|c00FFCC33 Spellsteal Links -- /sspl for more.|r");
    SpellstealPartyLinksDB= {
    ssplonoff = 1,
    SSPLSSPLOUTPUT = 'Auto',
    }

local SpellstealPartyLink = CreateFrame("Frame")

local function OnEvent(self, event, ...)
	local dispatch = self[event]

	if dispatch then
		dispatch(self, ...)
	end
end

SpellstealPartyLink:SetScript("OnEvent", OnEvent)
SpellstealPartyLink:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
SpellstealPartyLink:RegisterEvent("ADDON_LOADED")

function SpellstealPartyLink:ADDON_LOADED(...)
    if (event=="ADDON_LOADED") and (arg2=="SpellstealPartyLinks") then
    --print("variables were loaded.")
    self:UnregisterEvent("ADDON_LOADED")
    --print("event was unregistered.")
    if not SpellstealPartyLinksDB then
    SpellstealPartyLinksDB= {
    ssplonoff = 1,
    SSPLSSPLOUTPUT = 'Auto',
    }
    end
end
end

function SpellstealPartyLink:COMBAT_LOG_EVENT_UNFILTERED(...)
local inParty = GetNumPartyMembers()>=1
local inRaid = GetNumRaidMembers()>=1 -- changed from 5 to 1 to announce in raids with 2 or more instead of 6+
local aEvent = select(2, ...)
local aUser = select(5, ...)
local destName = select(9, ...)
local spellsID = select(15, ...)
	if SpellstealPartyLinksDB.ssplonoff==1 then
    if aEvent=="SPELL_STOLEN" then
		if inParty then xxx="PARTY" end
		local ssInInstance, ssinstanceType = IsInInstance(); -- added for bg compatibility
		if ssinstanceType == "pvp" then 
		xxx="BATTLEGROUND" 
		else
		if inRaid then xxx="RAID" end -- moved inside the bg check so if in a raid but not a bg it will still /raid
		end
    if aUser~=UnitName("player") then return end 
	local ssplsaymsg = " stole " .. GetSpellLink(spellsID) .. " from " ..destName.. "."
	if SpellstealPartyLinksDB.SSPLOUTPUT=='Self' then
            print("|c00FFCC33=> You"..ssplsaymsg)
        elseif SpellstealPartyLinksDB.SSPLOUTPUT=='Say' then
            if xxx == "pvp" then
				print("|c00FFCC33=> You"..ssplsaymsg)
			else
				SendChatMessage("=> I"..ssplsaymsg, "SAY")
			end
        elseif SpellstealPartyLinksDB.SSPLOUTPUT=='Auto' then 
            if (not inParty) and (not inRaid) then
                print("|c00FFCC33=> You"..ssplsaymsg)
            else SendChatMessage("=> I"..ssplsaymsg, xxx)
            end
        end
    end
end 
end

function sspltoggle()
	if SpellstealPartyLinksDB.ssplonoff==1 then
		SpellstealPartyLinksDB.ssplonoff=0
		print("|c00FFCC33Spellsteal Linker is now off.|r")
	else
		SpellstealPartyLinksDB.ssplonoff=1
		print("|c00FFCC33Spellsteal Linker is now on.|r")
	end
end

SLASH_SSPL1="/spl"
SLASH_SSPL1="/sspl"
SlashCmdList["SSPL"] = function(fwah)
local outputlist = " say [] self [] auto |r"
local list = "|c00FFCC33info [] toggle []" ..outputlist
local omgrly = "|c00FFCC33Output is: "
if (fwah == "") then print(list) end
if (fwah == "info") or (fwah == "Info") then print(list)
    if SpellstealPartyLinksDB.ssplonoff~=1 then print("|c00FFCC33Spellsteal Linker is off.") else print(omgrly, SpellstealPartyLinksDB.SSPLOUTPUT) end end
if (fwah == "toggle") or (fwah == "Toggle") then sspltoggle() end
    if (fwah == "Say") or (fwah == "say") then SpellstealPartyLinksDB.SSPLOUTPUT = 'Say' print(omgrly, SpellstealPartyLinksDB.SSPLOUTPUT)
    elseif (fwah == "Self") or (fwah == "self") then SpellstealPartyLinksDB.SSPLOUTPUT = 'Self' print(omgrly, SpellstealPartyLinksDB.SSPLOUTPUT)
    elseif (fwah == "Auto") or (fwah == "auto") then SpellstealPartyLinksDB.SSPLOUTPUT = 'Auto' print(omgrly, SpellstealPartyLinksDB.SSPLOUTPUT) end
if (fwah~="info")and(fwah~="Info")and(fwah~="")and(fwah~="toggle")and(fwah~="Toggle")and
    (fwah~="Say")and(fwah~="say")and(fwah~="Self")and(fwah~="self")and(fwah~="Auto")and(fwah~="auto")then
    print("Not a valid argument. =( ") end
end
